function hx=normalized_entropy(x, opt)
%hx=normalized_entropy(x, opt)
% Modified Ben's normalized entropy algorithm
% if opt = 1, normalize by the range, otherwise standardize

if nargin< 2
    opt=0;
end

if opt==1
    m = min(x);
    M = max(x);
    x = (x - m) / (M - m);
else
    x = (x - mean(x)) / std(x);
end
x = sort(x);
delta = x(2:end)-x(1:end-1);
dm = min(delta);
if dm == 0 % Replace 0 values by smallest second distance over max distance
    dd = delta;
    dd(dd==dm) = Inf;
    dm = min(dd);
    dM = max(delta);
    delta(delta==0)=dm/dM;
end

hx = - mean(log(delta)) / log(length(x)); %+ psi(length(x)) - psi(1);

