%this_dir=pwd;
%cd ('/Users/isabelle/Documents/MATLAB/CLOP');
%use_spider_clop;
%cd(this_dir);

% Mini examples of causal discovery
np=500;

% Example for A-B
CEbrowse; % select test set
P=get_X(D, num);
rp=randperm(length(P.A));
x=P.A(rp(1:500));
y=P.B(rp(1:500));
show(CEpair(x, y));
minifit(x, y, 2);

save('lv_example', 'x', 'y');

% Gaussian both, does not work
x=randn(np,1);
y=3*x+2+randn(np,1);
minifit(x, y);

% Gaussian noise but x unif
x=rand(np,1);
y=3*x+2+randn(np,1);
minifit(x, y);

% Gaussian x but noise unif
x=randn(np,1);
y=3*x+2+5*rand(np,1);
minifit(x, y);

% Both unif
x=rand(np,1);
y=3*x+2+rand(np,1);
%show(CEpair(x, y));
%minifit(x, y, 2);

% Reverse
show(CEpair(y, x));
minifit(y, x, 2);

% NL Gaus Gaus
x=randn(np,1);
y=tanh(5*x)+randn(np,1);
minifit(x, y, 2);

% NL Gaus Gaus
x=randn(np,1);
y=exp(x)+randn(np,1);
minifit(x, y, 2);

% Exp Gaus Gaus
x=randn(np,1);
y=exp(-x)+randn(np,1);
%show(CEpair(x, y));
%minifit(x, y, 2);

% Switch the axes
show(CEpair(y, x));
minifit(y, x, 2);

% 1/x unif Gaus
x=(1+rand(np,1))/2;
y=1./x*randn(np,1);
%show(CEpair(x, y));
%minifit(x, y, 2);

% Switch the axes
show(CEpair(y, x));
minifit(y, x, 2);

% Non linear example, our favorite temperature/altitude pair
load('/Users/isabelle/Documents/Projects/Challenges/CauseEffectPairs/FormatData/RAWDATA/MPI_CE');
x=log(1+CE(1).C);
y=CE(1).E;
minifit(x, y, 2);

d=CEpair(x, y, '', '', ['log(' CE(1).Cid ')'], CE(1).Eid);
show(d);

k=2; show(CEpair(CE(k).C, CE(k).E, '', '', CE(k).Cid, CE(k).Eid));

% Exponential looking
k=15;
x=CE(k).C;
y=log(1+CE(k).E);
show(CEpair(x, y));
minifit(x, y, 2);

k=15;
x=CE(k).C;
y=CE(k).E;
show(CEpair(x, y));
minifit(x, y, 2);

% Switch the axes
show(CEpair(y, x));
minifit(y, x, 2);

% Parabola
x=1:99; y=100-(-49:49).^2;
figure; plot(x, y, 'r-', 'Linewidth', 2); axis square;
minifit(x', y', 2);


% Indep
x=CE(22).C; x=x(randperm(length(x)));
y=CE(24).E; y=y(randperm(length(y)));
x=x(1:150);
y=y(1:150);
show(CEpair(x, y));
minifit(x, y, -2);

% Age/wages : not so easy
x=CE(12).C;
y=CE(12).E;
rp=randperm(length(x));
x=x(rp(1:np));
y=y(rp(1:np));
minifit(x, y, 2);

% Overfit 
np=10;
x=randn(10,1);
y=3*x+2+randn(10,1);
minifit(x, y, 3);

% Sigmoid
np=100;
x=rand(np,1);
y=tanh(5*(x-0.5));
minifit(x, y, -1);

x=rand(np,1);
y=atanh(2*x-1);
minifit(y, x, -1);

% Inversion and stability
np=100;
x=10*(rand(np,1)-0.5);

y=tanh(x+1);
minifit(x, y, -1);


x0=2*(rand(np,1)-0.5);
y0=atanh(x0);
[nx0,xx0]=hist(x0);
[ny0,yy0]=hist(y0);

for k=-1:.5:1
    y=atanh(x0)+k;
    minifit(x0, y, -1);
    ny=hist(y, yy0);
    title(['KLdiv(B0, B)=' sprintf('%5.2f', kldiv(ny0, ny))], 'FontSize', 16, 'FontWeight', 'bold');
end

for k=-1:.5:1
    x=tanh(y0-k);
    minifit(x, y0, -1);
    nx=hist(x, xx0);
    title(['KLdiv(A0, A)=' sprintf('%5.2f', kldiv(nx0, nx))], 'FontSize', 16, 'FontWeight', 'bold');
end

