function [info, header]=get_info(data_dir, set_name)
%[info, header]=get_info(data_dir, set_name)
% data_dir is a directory containing 2 subdirectories 'PUBLIC' and
% 'PRIVATE' 
% Returns:
% info -- a (P, N) cell array containing pattern private information
% header -- column header

% Isabelle Guyon -- isabelle@clopinet.com -- May 2013

if nargin<2, set_name=''; end
pdir=[data_dir '/PRIVATE/'];
pfile='*privateinfo.csv';


header=[];
info={};
direc = dir([pdir pfile]); filenames = {};
[filenames{1:length(direc),1}] = deal(direc.name);

for k=1:length(filenames)   
    if ~isempty(strfind(filenames{k}, set_name)) || isempty(set_name)
            X=read_mixed_csv([pdir filenames{k}]);
            header=X(1,:);
            info=[info; X(2:end,:)];
    end
end


