function yhat=browse(this, h, mymodel)
%yhat=browse(this, h, mymodel)
% Graphical display of patterns
% optionally returns truth values if the user inputs them instead of n for next:
% A->B gg=absolutely g=yep m=dunno b=nope bb=noway

% Isabelle Guyon -- isabelle@clopinet.com -- February 2013

if nargin<2 || isempty(h), h=figure('Position', [0 245 560 560]); else figure(h); end
if nargin<3, mymodel=[]; end

y=get_Y(this);
y(y==0)=-1;
yhat=zeros(size(y));

N=length(this);
n=-2;
gg=-3;
g=-4;
m=-5;
b=-6;
bb=-7;
p=-1;
e=0;
num=1;
while 1

    show(this, num, h);
    set(h, 'Name',  ['Pattern ' num2str(num) ' / ' num2str(N)]);

    idx = input('Pattern number (or n for next, p for previous, e exit)? ');
    if isempty(idx), idx=n; end
    switch idx
    case {n, gg, g, m, b, bb}
        if idx~=n
            yhat(num)=idx;
        end
        num=num+1;
        if num>N, num=1; end
    case p
        num=num-1;
        if num<1, num=N; end
    case e
        fprintf('AUC=%5.2f\n', auc(yhat, y)); 	
        break
    otherwise
        num=idx;
    end
    if ~isempty(mymodel)
        pair=get_X(this, num);

        warning off % Ignore causa test warnings
        score=exec(mymodel, pair)
        warning on
    end
    
end


