%==========================================================================
% preprocessing method to preprocess CE pairs        
%==========================================================================
% a=preprocessing(hyper) 
%
% model=preprocessing;
% [resu, model]=train(model, data)
% resu = test(model, data)
% This is a base class, it does nothing.
% You can derive preprocessing objects from this class.

%Isabelle Guyon -- isabelle@clopinet.com -- May 2013

classdef preprocessing
    
    properties (SetAccess = public)
        verbosity=0;            % Flag to turn on verbose mode for debug
        test_on_training_data=0;% Flag to turn on training data
    end

    methods
    
        function pair = exec(this, pair)
            %score = exec(this, pattern)
            % Does nothing...

        end
        
        function [mydata, this]=train(this, mydata)
            %[mydata, this]=train(mymodel, mydata)
            % This is a place holder, no training is performed.
            % Inputs/returns:
            % this     -- A recognizer object.
            % mydata   -- A data object.
            
            % Just test the training examples, no training or adjustment of
            % hyper-parameters. 
            myresu=test(this, mydata);
        end
        
        function mydata = test(this, mydata)
            %mydata = test(this, mydata)
            % Make predictions with indep_test and causa_test.
            % Inputs:
            % model -- A recog_template object.
            % mydata -- A data structure.
            
            P=length(mydata); 
            for k=1:P
                pair=get_X(mydata, k);
                pair=exec(this, pair);
                set_X(mydata, k, pair);
            end

            if this.verbosity>0, fprintf('\n==TE> Done testing %s... ', class(this)); end
        end
        
    end %methods
end %classdef
  

 

 
 





