%==========================================================================
% quantize method to preprocess CE pairs        
%==========================================================================
% a=quantize(hyper) 
%
% model=quantize;
% [resu, model]=train(model, data)
% resu = test(model, data)

%Isabelle Guyon -- isabelle@clopinet.com -- May 2013

classdef quantize < preprocessing
    
    properties (SetAccess = public)
        num=100;            % Number of quantization levels
        zero_base=0;        % 1 if the mean is shifted to have values starting at 0
    end

    methods
        
        function a=quantize(hyper)
            eval_hyper;
        end
    
        function pair = exec(this, pair)
            %score = exec(this, pattern)
            % Compute standardize a single pair
            num=this.num;
            
            A=get_A(pair);
            B=get_B(pair);
            
            if this.zero_base            
                A=round((A-min(A))./(eps+max(A)-min(A))*(num-1));
                A(A==num)=num-1;
                A(A<0)=0;

                B=round((B-min(B))./(eps+max(B)-min(B))*(num-1));
                B(B==num)=num-1;
                B(B<0)=0;
            else
                A=round((A-mean(A))./(eps+std(A))*num);
                B=round((B-mean(B))./(eps+std(B))*num);
            end
            
            
            set_A(pair, [], A);
            set_B(pair, [], B);
        end
        
    end %methods
    
end %classdef
  

 

 
 





